#include<bits/stdc++.h>
#define pb push_back
using namespace std;

int n, t, a[200010];
vector<int> poz;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i=0; i<n; i++) {
        cin >> a[i];
    }
    for(int i=0; i<n-1; i++) {
        if(a[i]>a[i+1]) {
            poz.pb(i);
        }
    }
    cin >> t;
    while(t--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int gdel=lower_bound(poz.begin(), poz.end(), l)-poz.begin();
        int gder=lower_bound(poz.begin(), poz.end(), r)-poz.begin();
        if(gder-gdel>=2) cout << "NE\n";
        else if(gdel==gder || poz[gdel]==l || a[poz[gdel]-1]<=a[poz[gdel]+1]) cout << "DA\n";
        else cout << "NE\n";
    }
    return 0;
}